﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10.5
@EndOfDesignText@
#region doc
'https://wiki.openstreetmap.org/wiki/Slippy_map_tilenames#X_and_Y
#end region

#region designer
#DesignerProperty: Key: centerLat, DisplayName: Latitude at center, FieldType: float, DefaultValue: 0
#DesignerProperty: Key: centerLng, DisplayName: Longitude at center, FieldType: float, DefaultValue: 0
#DesignerProperty: Key: zoomLevel, DisplayName: Zoom Level, FieldType: int, DefaultValue: 0,MinRange: 0, MaxRange: 17,
#DesignerProperty: Key: compassDirection, DisplayName: Compass Direciton, FieldType: float, DefaultValue: 0,MinRange: 0, MaxRange: 360,
#DesignerProperty: Key: offlineMode, DisplayName: Offline Mode, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: showMenu, DisplayName: Display Menu, FieldType: boolean, DefaultValue: false
#DesignerProperty: Key: showGrid, DisplayName: Display Grid, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: showCenter, DisplayName: Display Center, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: showLandmark, DisplayName: Display Landmark, FieldType: boolean, DefaultValue: false
#DesignerProperty: Key: showCenterLatLng, DisplayName: Display Lat/Lng, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: showZoom, DisplayName: Display Zoom, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: showScale, DisplayName: Display Scale, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: showCompass, DisplayName: Display Compass, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: showMarkers, DisplayName: Display Markers, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: showGPS, DisplayName: Display GPS, FieldType: boolean, DefaultValue: true
#event:ready
#event:MenuClicked
#event:ScaleClicked(aScale as double)
#event:CenterlatlngClicked(alatLng as TLatLng)
#event:CenterLatLngChanged(aOldlatLng as TLatLng,aNewLatLng as TLatLng)
#event:zoomLevelChanged(aOldZzoomLEvel as int,aNewZoomLevel)
#event:compassDirectionChanged(aOldDirection as double,aNewDirection as double)
#event:compassClicked(adegres as double)
#event:marKerClicked(adata as object)
#event:mapClicked(aLatLng as TMapLatLng)
#event:gpsClicked(aGPS as TMapGPS)
#end region

#region globals
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private fxui As XUI 'ignore
	Public Tag As Object
	'private constants
	Private const cTileLayerImage As Int=0
	Private const cTileLayerGrid As Int=1
	Private const cTileLayerMarkers As Int=2
	Private const cTileLayerGPS As Int=3
	'private fields
	Private cMarkerWidth As Float=16dip
	Private cMarkerHeight As Float=32dip
	Private cGPSWidth As Float=30dip
	Private cGPSHeight As Float=30dip
	Private fMapTileManager As clMapTileManager
	Private fMap As TMap
	Private fPanelTilesAndTouch As B4XView
	Private fPanelTiles As B4XView
	Private fPanelTouch As B4XView
	Private fPanelCenter As B4XView
	Private fPanelLandmark As B4XView
	Private fPanelCompass As B4XView
	Private fCompassBitmap(2) As B4XBitmap
	Private fTilesCount As Long
	Private fIsMoving As Boolean=False
	Private fLabelCenterLatLng As B4XView
	Private fPanelZoom As B4XView
	Private fLabelZoomLevel As B4XView
	Private fPanelScale As B4XView
	Private fLabelScale As B4XView
	Private fPanelRuler As B4XView
	Private fButtonMenu As B4XView
	Private fLastTouch As TMapPoint
	Private fStartTouch As TMapPoint
	Private fImageViewCompass As B4XView
	Private fLabelCompassDirection As B4XView
End Sub
#end region

#region initialization
Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	fMap.Initialize
	fMap.fMarkers.Initialize
	fLastTouch.Initialize
	fStartTouch.Initialize
	fMapTileManager.Initialize
End Sub

'on base resize event
Private Sub Base_Resize (Width As Double, Height As Double)
	If fPanelTilesAndTouch.IsInitialized Then
		mBase.RemoveAllViews
		rearrange
		draw
	End If
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Tag = mBase.Tag
	mBase.Tag = Me
	CallSubDelayed2(Me,"LoadLayout",Props)
End Sub

'load layout and raise ready event
private Sub LoadLayout(aProps As Map)
	rearrange
	'init B4XBitmap for compass
	fCompassBitmap(0)=fxui.LoadBitmapResize(File.DirAssets,"compass0.png",fImageViewCompass.Width,fImageViewCompass.Height,True)
	fCompassBitmap(1)=fxui.LoadBitmapResize(File.DirAssets,"compassx.png",fImageViewCompass.Width,fImageViewCompass.Height,True)
	'init map info and options from custom properties
	fMap.Initialize
	fMap.fGPS=coMapUtilities.initGPS(coMapUtilities.initLatLng(0,0),0)
	
	setCenterLatLng(coMapUtilities.initLatLng(aProps.GetDefault("centerLat",0),aProps.GetDefault("centerLng",0)))
	setZoomLevel(aProps.GetDefault("zoomLevel",0))
	setCompassDirection(aProps.GetDefault("compassDirection",0))
	setShowCenter(aProps.GetDefault("showCenter",True))
	setOfflineMode(aProps.GetDefault("offlineMode",False))
	setShowMenu(aProps.GetDefault("ShowMenu",True))
	setShowGrid(aProps.GetDefault("ShowGrid",True))
	setShowLandmark(aProps.GetDefault("ShowLandmark",True))
	setShowCenterLatLng(aProps.GetDefault("ShowCenterLatLng",True))
	setShowZoom(aProps.GetDefault("ShowZoom",True))
	setShowScale(aProps.GetDefault("ShowScale",True))
	setShowCompass(aProps.GetDefault("ShowCompass",True))
	setShowMarkers(aProps.GetDefault("ShowMarkers",True))
	setShowGPS(aProps.GetDefault("ShowGPS",True))
	'raise event ready
	CallSub(mCallBack,mEventName & "_ready")
End Sub

private Sub rearrange
	mBase.LoadLayout("cvmap")
	'calc diag of map and resize panel
	Dim diag As Double=Sqrt(Power(mBase.Width,2)+Power(mBase.Height,2))
	fPanelTilesAndTouch.Width=diag
	fPanelTilesAndTouch.Height=diag
	fPanelTilesAndTouch.Left=-(fPanelTilesAndTouch.Width-mBase.Width)/2
	fPanelTilesAndTouch.Top=-(fPanelTilesAndTouch.Height-mBase.Height)/2
	fPanelTouch.Width=fPanelTilesAndTouch.Width
	fPanelTouch.Height=fPanelTilesAndTouch.Height
	fPanelTiles.Width=fPanelTilesAndTouch.Width
	fPanelTiles.Height=fPanelTilesAndTouch.Height
	fPanelCenter.Width=fPanelTilesAndTouch.Width
	fPanelCenter.Height=fPanelTilesAndTouch.Height
	fPanelLandmark.Width=fPanelTilesAndTouch.Width
	fPanelLandmark.Height=fPanelTilesAndTouch.Height
	'draw center on fpanelcenter
	Dim c As B4XCanvas
	c.Initialize(fPanelCenter)
	c.DrawCircle(fPanelCenter.Width/2,fPanelCenter.Height/2,10dip,fxui.Color_Red,False,2dip)
	c.Invalidate
	'draw landmark on fpanellandmark
	Dim c As B4XCanvas
	c.Initialize(fPanelLandmark)
	c.DrawLine(fPanelLandmark.Width/2,0,fPanelLandmark.Width/2,fPanelLandmark.Height,fxui.Color_Red,1dip)
	c.DrawLine(0,fPanelLandmark.Height/2,fPanelLandmark.Width,fPanelLandmark.Height/2,fxui.Color_Red,1dip)
	c.Invalidate
End Sub

#end region

#region options/infos setter/getter
public Sub setShowMenu(avalue As Boolean)
	fMap.fShowMenu=avalue
	fButtonMenu.Visible=avalue
End Sub

public Sub getShowMenu As Boolean
	Return fMap.fShowMenu
End Sub

public Sub setShowGrid(avalue As Boolean)
	fMap.fShowGrid=avalue
	ShowHideTileLayer(cTileLayerGrid,avalue)
End Sub

public Sub getShowGrid As Boolean
	Return fMap.fShowGrid
End Sub

public Sub setShowCenter(avalue As Boolean)
	fMap.fShowCenter=avalue
	fPanelCenter.Visible=avalue
End Sub

public Sub getShowCenter As Boolean
	Return fMap.fshowCenter
End Sub

public Sub setShowMarkers(avalue As Boolean)
	fMap.fShowMarkers=avalue
	ShowHideTileLayer(cTileLayerMarkers,avalue)
End Sub

public Sub getShowMarkers As Boolean
	Return fMap.fShowMarkers
End Sub

public Sub setShowGPS(avalue As Boolean)
	fMap.fShowGPS=avalue
	ShowHideTileLayer(cTileLayerGPS,avalue)
End Sub

public Sub getShowGPS As Boolean
	Return fMap.fShowGPS
End Sub

public Sub setShowLandmark(avalue As Boolean)
	fMap.fShowLandmark=avalue
	fPanelLandmark.Visible=avalue
End Sub

public Sub getShowLandmark As Boolean
	Return fMap.fShowLandmark
End Sub

public Sub setShowCenterLatLng(avalue As Boolean)
	fMap.fShowCenterLatLng=avalue
	fLabelCenterLatLng.Visible=avalue
End Sub

public Sub getShowCenterLatLng As Boolean
	Return fMap.fShowCenterLatLng
End Sub

public Sub setShowZoom(avalue As Boolean)
	fMap.fShowZoom=avalue
	fPanelZoom.Visible=avalue
End Sub

public Sub getShowZoom As Boolean
	Return fMap.fShowZoom
End Sub

public Sub setShowScale(avalue As Boolean)
	fMap.fShowScale=avalue
	fPanelScale.Visible=avalue
End Sub

public Sub getShowScale As Boolean
	Return fMap.fShowScale
End Sub

public Sub setOfflineMode(avalue As Boolean)
	fMap.fOfflineMode=avalue
	fMapTileManager.Offline=avalue
End Sub

public Sub getOfflineMode As Boolean
	Return fMap.fOfflineMode
End Sub

public Sub setShowCompass(avalue As Boolean)
	fMap.fShowCompass=avalue
	fPanelCompass.Visible=avalue
End Sub

public Sub getShowCompass As Boolean
	Return fMap.fshowCompass
End Sub

Public Sub setZoomLevel(avalue As Int)
	fMap.fZoomLevel=coMapUtilities.validZoomLevel(avalue)
	fPanelTiles.RemoveAllViews
	fTilesCount=Power(2,fMap.fZoomLevel)
	fLabelZoomLevel.Text=$"${fMap.fZoomLevel}/${coMapUtilities.cMaxZoomLevel}"$
	CallSub2(mCallBack,mEventName & "_zoomLevelChanged",fMap.fZoomLevel)
End Sub

public Sub getZoomLevel As Int
	Return fMap.fZoomLevel
End Sub

Public Sub setCompassDirection(avalue As Double)
	If avalue=fMap.fCompassDirection Then
		Return
	End If
	fMap.fCompassDirection=coMapUtilities.validCompassDirection(avalue)
	update_CompassDirection
End Sub

public Sub getCompassDirection As Double
	Return fMap.fCompassDirection
End Sub

Public Sub setCenterLatLng(avalue As TMapLatLng)
	fMap.fCenterLatLng.fLat=coMapUtilities.validLat(avalue.fLat)
	fMap.fCenterLatLng.fLng=coMapUtilities.validLng(avalue.fLng)
	update_CenterLatLng
End Sub

public Sub getCenterLatLng As TMapLatLng
	Return fMap.fCenterLatLng
End Sub
#end region

private Sub ShowHideTileLayer(aLayer As Int,aShowHide As Boolean)
	For i=0 To fPanelTiles.NumberOfViews-1
		Dim pt As B4XView=fPanelTiles.GetView(i)
		Dim pm As B4XView=pt.GetView(aLayer)
		pm.Visible=aShowHide
	Next
End Sub

#region draw Map
public Sub draw
	createTiles(fMap.fCenterLatLng,fMap.fZoomLevel)
	update_Scale
	update_CompassDirection
	update_CenterLatLng
End Sub
#end region

#region conversion Map, Center, Point, X/Y, Lat/Lng, Tile
'return tile which contains point X/Y
Private Sub PointToTile(aX As Int,aY As Int) As B4XView
	For i=0 To fPanelTiles.NumberOfViews-1
		Dim t As B4XView=fPanelTiles.GetView(i)
		If (t.Left<=aX) And (t.Left+t.Width>=aX) And (t.Top<=aY) And (t.Top+t.Height>=aY) Then
			Return t
		End If
	Next
	Return Null
End Sub

'return the tile which is number X and Y
private Sub XYToTile(aX As Long,aY As Long) As B4XView
	For i=0 To fPanelTiles.NumberOfViews-1
		Dim v As B4XView=fPanelTiles.GetView(i)
		Dim t As TMapTileXY=v.Tag
		If t.fX=aX And t.fY=aY Then
			Return v
		End If
	Next
	Return Null
End Sub


'return box lat/lng from map
public Sub MapToBoxLatLng As TMapBoxLatLng
	Dim bll As TMapBoxLatLng
	bll.Initialize
	bll.fLeftTop=PointToLatLng(coMapUtilities.initPoint(0,0))
	bll.fRightBottom=(PointToLatLng(coMapUtilities.initPoint(fPanelTiles.Width,fPanelTiles.Height)))
	Return bll
End Sub

'return lat/lng from center map
public Sub MapCenterToLatLng As TMapLatLng
	Return PointToLatLng(coMapUtilities.initPoint(fPanelTouch.Width/2,fPanelTouch.Height/2))
End Sub

'return  TMapPoint from TMapLatLng
public Sub LatLngToPoint(aLatLng As TMapLatLng) As TMapPoint
	Dim bll As TMapBoxLatLng=MapToBoxLatLng
	Return coMapUtilities.initPoint(1.0*fPanelTiles.Width/(bll.fRightBottom.fLng-bll.fLeftTop.fLng)*(aLatLng.fLng-bll.fLeftTop.fLng), _
	                                1.0*fPanelTiles.height/(bll.fRightBottom.fLat-bll.fLeftTop.fLat)*(aLatLng.fLat-bll.fLeftTop.fLat))
End Sub

'return lat/lng from point on map
public Sub PointToLatLng(aPoint As TMapPoint) As TMapLatLng
	Dim ll As TMapLatLng
	ll.Initialize
	Dim ti As B4XView=PointToTile(aPoint.fX,aPoint.fY)
	If ti.IsInitialized Then
		Dim txy As TMapTileXY=ti.tag
		ll.fLng=coMapUtilities.TileXToLng(txy.fX,aPoint.fX-ti.left,fMap.fZoomLevel)
		ll.fLat=coMapUtilities.TileYToLat(txy.fy,aPoint.FY-ti.top,fMap.fZoomLevel)
	Else
		ll.fLat=0
		ll.fLng=0
	End If
	Return ll
End Sub
#end region

#region update_map

public Sub update_Scale
	Dim m As Double=CalcScale(fMap.fCenterLatLng.fLat,fMap.fZoomLevel)
	fPanelScale.SetLayoutAnimated(0,5dip,mBase.Height-45dip,138dip,40dip)
	fPanelRuler.SetLayoutAnimated(0,5dip,30dip,128dip,5dip)
	fLabelScale.SetLayoutAnimated(0,5dip,5dip,128dip,20dip)
	fLabelScale.Text=distanceStr(m/2)
End Sub

public Sub update_CompassDirection
	fImageViewCompass.Rotation=fMap.fCompassDirection
	fLabelCompassDirection.Text=$"$1.0{fMap.fCompassDirection}°"$
	If fMap.fCompassDirection=0 Then
		fImageViewCompass.SetBitmap(fxui.LoadBitmapResize(File.DirAssets,"compass0.png",fImageViewCompass.Width,fImageViewCompass.Height,True))
	Else
		fImageViewCompass.SetBitmap(fxui.LoadBitmapResize(File.DirAssets,"compassx.png",fImageViewCompass.Width,fImageViewCompass.Height,True))
	End If
	fPanelTilesAndTouch.Rotation=fMap.fCompassDirection
	CallSub2(mCallBack,mEventName & "_compassDirectionChanged",fMap.fCompassDirection)
End Sub

public Sub update_CenterLatLng
	fLabelCenterLatLng.Text=$"Lat : ${NumberFormat2(fMap.fCenterLatLng.fLat,1,5,5,False)} | Lng : ${NumberFormat2(fMap.fCenterLatLng.fLng,1,5,5,False)}"$
	CallSub2(mCallBack,mEventName & "_centerLatLngChanged",fMap.fCenterLatLng)
End Sub

#end region

#region create/draw tiles
'draw tile
public Sub drawTile(aImageTile As B4XView,aZ As Int,aX As Long,aY As Long)
	wait for (fMapTileManager.getTile(aZ,aX,aY)) complete (result As B4XBitmap)
	Try
		aImageTile.setBitmap(result)
	Catch
		Log(LastException.Message)
	End Try
End Sub

'return tile in interval 0..fTilesCount-1
private Sub checkTile(aTile As Int,aTilesNumber As Int) As Int
	If aTile<0 Then
		aTile=aTilesNumber+aTile
	End If
	Return (aTile Mod aTilesNumber)
End Sub

'add tile
private Sub addTile(aLeft As Int,aTop As Int,aTileX As Long,aTileY As Long,aZ As Int)
	aTileX=checkTile(aTileX,fTilesCount)
	aTileY=checkTile(aTileY,fTilesCount)
	'view for the tile
	#if b4A or b4i
	Dim pt As Panel
	#else if b4J
		Dim pt As Pane
	#end if
	pt.Initialize("tile")
	Dim xpt As B4XView=pt
	xpt.Tag=coMapUtilities.initTileXY(aTileX,aTileY)
	fPanelTiles.AddView(pt,aLeft,aTop,coMapUtilities.cTileSize,coMapUtilities.cTileSize)
	'view for the tile's image
	Dim iv As ImageView
	iv.Initialize("itile")
	xpt.AddView(iv,0,0,coMapUtilities.cTileSize,coMapUtilities.cTileSize)
	drawTile(iv,aZ,aTileX,aTileY)
	'view for the grid
	#if b4A or B4i
	Dim pg As Panel
	#else if b4J
		Dim pg As Pane
	#end if
	pg.Initialize("gtile")
	xpt.AddView(pg,0,0,coMapUtilities.cTileSize,coMapUtilities.cTileSize)
	drawGridOnTile(pg)
	pg.Visible=fMap.fShowGrid
	'view for the markers
	#if b4A or b4i
	Dim pm As Panel
	#else if b4J
		Dim pm As Pane
	#end if
	pm.Initialize("mtile")
	pm.Tag=xpt.Tag
	xpt.AddView(pm,0,0,coMapUtilities.cTileSize,coMapUtilities.cTileSize)
	drawMarkersOnTile(pm)
	pm.Visible=fMap.fshowMarkers
	'view for the GPS
	#if b4A or b4i
	Dim pp As Panel
	#else if b4J
		Dim pp As Pane
	#end if
	pp.Initialize("stile")
	pp.Tag=xpt.Tag
	xpt.AddView(pp,0,0,coMapUtilities.cTileSize,coMapUtilities.cTileSize)
	drawGPSOnTile(pp)
	pp.Visible=fMap.fShowGPS
End Sub

private Sub addGPSOnTile(aView As B4XView,aLeft As Int,aTop As Int,aAngle As Int)
	#if b4A or b4i
	Dim g As Panel
	#else if b4J
		Dim g As Pane
	#end if
	g.Initialize("gps")
	aView.AddView(g,aLeft-(cGPSWidth/2),aTop-(cGPSHeight/2),cGPSWidth,cGPSHeight)
	Dim c As B4XCanvas
	c.Initialize(g)
	c.DrawBitmapRotated(fxui.LoadBitmapResize(File.DirAssets,"bearing.png",cGPSWidth,cGPSHeight,True),c.TargetRect,aAngle)
	c.Invalidate
End Sub

private Sub addMarkerOnTile(aView As B4XView,aKey As String,aMarker As TMapMarker,aLeft As Int,aTop As Int)
	#if b4A or b4i
	Dim ma As Panel
	#else if b4J
		Dim ma As Pane
	#end if
	ma.Initialize("marker")
	ma.Tag=aKey
	aView.AddView(ma,aLeft-(cMarkerWidth/2),aTop-cMarkerHeight,cMarkerWidth,cMarkerHeight)
	Dim c As B4XCanvas
	c.Initialize(ma)
	Dim d As B4XPath
	d.Initialize(0dip,0dip)
	d.LineTo(cMarkerWidth/2,cMarkerHeight)
	d.LineTo(cMarkerWidth,0dip)
	d.LineTo(0dip,0dip)
	c.DrawPath(d,aMarker.fColor,True,0)
	c.Invalidate
End Sub

private Sub drawGPSOnTile(aView As B4XView)
	Dim tileXY As TMapTileXY=aView.Tag
	Dim tx As TMapTileNumberOffset=coMapUtilities.LngToTileX(fMap.fgps.flatlng.fLng,fMap.fZoomLevel)
	Dim ty As TMapTileNumberOffset=coMapUtilities.LatToTileY(fMap.fgps.flatlng.fLat,fMap.fZoomLevel)
	If (tileXY.fX=tx.fTile) And (tileXY.fy=ty.fTile) Then
		addGPSOnTile(aView,tx.fOffset,ty.fOffset,fMap.fGPS.fBearing)
	Else
		If (checkTile(tileXY.fX+1,fTilesCount)=tx.fTile) And (tx.fOffset-(cMarkerWidth/2)<coMapUtilities.cTileSize) And (checkTile(tileXY.fy+1,fTilesCount)=ty.fTile) And (ty.fOffset-(cMarkerHeight/2)<coMapUtilities.cTileSize) Then
			addGPSOnTile(aView,tx.fOffset+coMapUtilities.cTileSize,ty.fOffset+coMapUtilities.cTileSize,fMap.fGPS.fBearing)
		Else
			If (checkTile(tileXY.fX+1,fTilesCount)=tx.fTile) And (tx.fOffset-(cMarkerWidth/2)<coMapUtilities.cTileSize) And (tileXY.fy=ty.fTile) Then
				addGPSOnTile(aView,tx.fOffset+coMapUtilities.cTileSize,ty.fOffset,fMap.fGPS.fBearing)
			Else
				If (tileXY.fX=tx.fTile) And (checkTile(tileXY.fy+1,fTilesCount)=ty.fTile) And (ty.fOffset-(cMarkerHeight/2)<coMapUtilities.cTileSize) Then
					addGPSOnTile(aView,tx.fOffset,ty.fOffset+coMapUtilities.cTileSize,fMap.fGPS.fBearing)
				End If
			End If
		End If
	End If
End Sub

private Sub drawMarkerOnTile(aKey As String,aMarker As TMapMarker,aView As B4XView)
	Dim tileXY As TMapTileXY=aView.Tag
	Dim tx As TMapTileNumberOffset=coMapUtilities.LngToTileX(aMarker.fLatLng.fLng,fMap.fZoomLevel)
	Dim ty As TMapTileNumberOffset=coMapUtilities.LatToTileY(aMarker.fLatLng.fLat,fMap.fZoomLevel)
	If (tileXY.fX=tx.fTile) And (tileXY.fy=ty.fTile) Then
		addMarkerOnTile(aView,aKey,aMarker,tx.fOffset,ty.fOffset)
	Else
		If (checkTile(tileXY.fX+1,fTilesCount)=tx.fTile) And (tx.fOffset-(cMarkerWidth/2)<coMapUtilities.cTileSize) And (checkTile(tileXY.fy+1,fTilesCount)=ty.fTile) And (ty.fOffset-cMarkerHeight<coMapUtilities.cTileSize) Then
			addMarkerOnTile(aView,aKey,aMarker,tx.fOffset+coMapUtilities.cTileSize,ty.fOffset+coMapUtilities.cTileSize)
		Else
			If (checkTile(tileXY.fX+1,fTilesCount)=tx.fTile) And (tx.fOffset-(cMarkerWidth/2)<coMapUtilities.cTileSize) And (tileXY.fy=ty.fTile) Then
				addMarkerOnTile(aView,aKey,aMarker,tx.fOffset+coMapUtilities.cTileSize,ty.fOffset)
			Else
				If (tileXY.fX=tx.fTile) And (checkTile(tileXY.fy+1,fTilesCount)=ty.fTile) And (ty.fOffset-cMarkerHeight<coMapUtilities.cTileSize) Then
					addMarkerOnTile(aView,aKey,aMarker,tx.fOffset,ty.fOffset+coMapUtilities.cTileSize)
				End If
			End If
		End If
	End If
End Sub

private Sub drawMarkersOnTile(aView As B4XView)
	For Each k As String In fMap.fMarkers.keys
		Dim m As TMapMarker=fMap.fMarkers.Get(k)
		drawMarkerOnTile(k,m,aView)
	Next
End Sub

public Sub addMarker(aKey As String,aMarker As TMapMarker)
	fMap.fMarkers.Put(aKey,aMarker)
	For i=0 To fPanelTiles.NumberOfViews-1
		Dim v As B4XView=fPanelTiles.GetView(i)
		Dim pm As B4XView=v.GetView(cTileLayerMarkers)
		drawMarkerOnTile(aKey,aMarker,pm)
	Next
End Sub

public Sub removeMarker(aKey As String)
	Dim lr As List
	lr.Initialize
	fMap.fMarkers.Remove(aKey)
	For i=0 To fPanelTiles.NumberOfViews-1
		Dim v As B4XView=fPanelTiles.GetView(i)
		Dim pm As B4XView=v.GetView(cTileLayerMarkers)
		For j=0 To pm.NumberOfViews-1
			Dim m As B4XView=pm.GetView(j)
			If aKey=m.Tag Then
				lr.Add(m)
			End If
		Next
	Next
	For Each v As B4XView In lr
		v.RemoveViewFromParent
	Next
End Sub

public Sub clearMarkers
	fMap.fMarkers.Clear
	For i=0 To fPanelTiles.NumberOfViews-1
		Dim v As B4XView=fPanelTiles.GetView(i)
		Dim pm As B4XView=v.GetView(cTileLayerMarkers)
		pm.RemoveAllViews
	Next
End Sub

private Sub drawGridOnTile(aView As B4XView)
	Dim c As B4XCanvas
	c.Initialize(aView)
	c.ClearRect(c.TargetRect)
	c.DrawLine(c.TargetRect.Width/2,0,c.TargetRect.Width/2,c.TargetRect.Height,fxui.Color_DarkGray,1dip)
	c.DrawLine(0,c.TargetRect.height/2,c.TargetRect.width,c.TargetRect.Height/2,fxui.Color_DarkGray,1dip)
	c.DrawRect(c.TargetRect,fxui.Color_Black,False,1dip)
	c.invalidate
End Sub

'create all tiles
private Sub createTiles(aLatLng As TMapLatLng,aZoom As Int)
	'retrieve tile X/Y and offset X/Y from lat/lng
	Dim x As TMapTileNumberOffset=coMapUtilities.LngToTileX(aLatLng.fLng,aZoom)
	Dim y As TMapTileNumberOffset=coMapUtilities.LatToTileY(aLatLng.fLat,aZoom)
	Dim l As Int=(fPanelTiles.Width/2)-x.fOffset
	Dim t As Int=fPanelTiles.height/2-y.fOffset


	'check if tile X/Y exists
	Dim txy As B4XView=XYToTile(x.fTile,y.fTile)
	If txy.IsInitialized Then
		'if True, just move tiles
		moveTiles(100,l-txy.Left,t-txy.Top)
	Else
		'else remove all and create all tiles
		'get first left/top tile to draw
		Do While l>0
			l=l-Floor(coMapUtilities.cTileSize)
			x.fTile=x.fTile-1
		Loop
		Do While t>0
			t=t-Floor(coMapUtilities.cTileSize)
			y.fTile=y.fTile-1
		Loop

		'remove all tiles
		fPanelTiles.RemoveAllViews
		
		'add all tiles
		Dim ti As Int
		Dim lj As Int
		Dim ty As Int
		Dim tx As Int
		lj=l
		tx=x.fTile
		Do While lj<fPanelTiles.Width
			ti=t
			ty=y.fTile
			Do While ti<fPanelTiles.Height
				addTile(lj,ti,tx,ty,fMap.fZoomLevel)
				ti=ti+coMapUtilities.cTileSize
				ty=ty+1
			Loop
			lj=lj+coMapUtilities.cTileSize
			tx=tx+1
		Loop
	End If
End Sub
#end region

#region move tiles
'move tiles up and down, remove invisible tiles, add missing visible tiles
Private Sub moveTilesY(aduration As Int,aMoveY As Int)
	Dim ti As TMapTileXY
	Dim y As Int
	Dim r As List
	r.Initialize
	For i=0 To fPanelTiles.NumberOfViews-1
		Dim t As B4XView=fPanelTiles.GetView(i)
		If t.top+aMoveY+coMapUtilities.cTileSize<0 Then
			r.Add(t)
		Else
			If t.top+aMoveY>fPanelTiles.Height Then
				r.Add(t)
			Else
				y=t.top
				t.SetLayoutAnimated(aduration,t.left,t.top+aMoveY,coMapUtilities.cTileSize,coMapUtilities.cTileSize)
				ti=t.tag
				If (y<=0) And (t.top>0) Then
					addTile(t.Left,t.top-coMapUtilities.cTileSize,ti.fX,ti.fy-1,fMap.fZoomLevel)
				Else
					If (y+coMapUtilities.cTileSize>=fPanelTiles.height) And (t.top+coMapUtilities.cTileSize<fPanelTiles.height) Then
						addTile(t.Left,t.top+coMapUtilities.cTileSize,ti.fX,ti.fy+1,fMap.fZoomLevel)
					End If
				End If
			End If
		End If
	Next
	For Each t As B4XView In r
		t.RemoveViewFromParent
	Next
End Sub

'move tiles left and right, remove invisible tiles, add missing visible tiles
Private Sub moveTilesX(aduration As Int,aMoveX As Int)
	Dim ti As TMapTileXY
	Dim x As Int
	Dim r As List
	r.Initialize
	For i=0 To fPanelTiles.NumberOfViews-1
		Dim t As B4XView=fPanelTiles.GetView(i)
		If t.Left+aMoveX+coMapUtilities.cTileSize<0 Then
			r.Add(t)
		Else
			If t.Left+aMoveX>fPanelTiles.Width Then
				r.Add(t)
			Else
				x=t.left
				t.SetLayoutAnimated(aduration,t.left+aMoveX,t.top,coMapUtilities.cTileSize,coMapUtilities.cTileSize)
				ti=t.tag
				If (x<=0) And (t.Left>0) Then
					addTile(t.Left-coMapUtilities.cTileSize,t.top,ti.fX-1,ti.fy,fMap.fZoomLevel)
				Else
					If (x+coMapUtilities.cTileSize>=fPanelTiles.width) And (t.Left+coMapUtilities.cTileSize<fPanelTiles.Width) Then
						addTile(t.Left+coMapUtilities.cTileSize,t.top,ti.fX+1,ti.fy,fMap.fZoomLevel)
					End If
				End If
			End If
		End If
	Next
	For Each t As B4XView In r
		t.RemoveViewFromParent
	Next
End Sub

'move tiles
private Sub moveTiles(aduration As Int,aMoveX As Int,aMoveY As Int)
	'move tiles
	moveTilesX(aduration,aMoveX)
	moveTilesY(aduration,aMoveY)
	Dim v As B4XView=fPanelTiles.GetView(0)
	#if B4i
		Dim l As Int=Bit.FMod(v.Left, coMapUtilities.cTileSize)
	Dim t As Int=Bit.FMod(v.Top,coMapUtilities.cTileSize)
	#Else 
		Dim l As Int=v.Left Mod coMapUtilities.cTileSize
		Dim t As Int=v.Top Mod coMapUtilities.cTileSize
	#End If
	
	If l<-coMapUtilities.cTileSize Then
		l=l+coMapUtilities.cTileSize
	End If
	If t<-coMapUtilities.cTileSize Then
		t=t+coMapUtilities.cTileSize
	End If
End Sub
#end region

#region Map
Public Sub setMap(aMap As TMap)
	setCenterLatLng(aMap.fCenterLatLng)
	setCompassDirection(aMap.fCompassDirection)
	setZoomLevel(aMap.fZoomLevel)
	setOfflineMode(aMap.fOfflineMode)
	setShowCenter(aMap.fshowCenter)
	setShowCenterLatLng(aMap.fShowCenterLatLng)
	setShowCompass(aMap.fShowCompass)
	setShowGrid(aMap.fShowGrid)
	setShowLandmark(aMap.fShowLandmark)
	setShowMarkers(aMap.fShowMarkers)
	setShowMenu(aMap.fShowMenu)
	setShowScale(aMap.fShowScale)
	setShowZoom(aMap.fShowZoom)
	fMap.fMarkers=aMap.fMarkers
End Sub

public Sub getMap As TMap
	Return fMap
End Sub
#end region

'zoom in/out and raise event zoomChanged
private Sub fButtonZoomInOut_click
	Dim b As Button=Sender
	setZoomLevel(fMap.fZoomLevel+b.Tag)
	createTiles(fMap.fCenterLatLng,fMap.fZoomLevel)
	update_Scale
End Sub
#end region

#region scale/LatLng
'format a distance (m or km)
private Sub distanceStr(aDistance As Double) As String
	If aDistance>1000 Then
		Return NumberFormat2(aDistance/1000,1,0,0,False) & "Km"
	Else
		Return NumberFormat2(aDistance,1,0,0,False) & "m"
	End If
End Sub

'calc distance for 128dip (horizontal) at this latitude and this zoom level
private Sub CalcScale(aLatitude As Double,aZoom As Int) As Double
	Return 40075016.686*Cos(aLatitude*cPI/180)/Power(2,aZoom)
End Sub

'raise event latlngClicked
#if B4A  or B4i
Private Sub fLabelCenterLatLng_Click
	CallSub2(mCallBack,mEventName & "_CenterlatlngClicked",fMap.fCenterLatLng)
End Sub
#else if B4J
	Private Sub fLabelCenterLatLng_MouseClicked (EventData As MouseEvent)
		CallSub2(mCallBack,mEventName & "_CenterlatlngClicked",fMap.fCenterLatLng)
	End Sub
#end if


'raise event scaleClicked
#if B4A or B4i
Private Sub fPanelScale_Click
	Dim ll As TMapLatLng=MapCenterToLatLng
	Dim s As Double=CalcScale(ll.fLat,fMap.fZoomLevel)
	CallSub2(mCallBack,mEventName & "_scaleClicked",s)
End Sub
#else if b4j
	Private Sub fPanelScale_MouseClicked (EventData As MouseEvent)
		Dim ll As TMapLatLng=MapCenterToLatLng
		Dim s As Double=CalcScale(ll.fLat,fMap.fZoomLevel)
		CallSub2(mCallBack,mEventName & "_scaleClicked",s)
	End Sub
#end if
#region menu
'raise event menuClicked
Private Sub fButtonMenu_Click
	CallSub(mCallBack,mEventName & "_menuClicked")
End Sub
#end region

'touch compass
Private Sub fPanelCompassTouch_Touch (Action As Int, X As Float, Y As Float)
	If Action = fPanelCompass.TOUCH_ACTION_MOVE_NOTOUCH Then
		Return
	End If
	#if b4i
		setCompassDirection(Bit.FMod((Round(ATan2D(y-fPanelCompass.Height/2,x-fPanelCompass.Width/2))+90+360), 360))
	#else
		setCompassDirection((Round(ATan2D(y-fPanelCompass.Height/2,x-fPanelCompass.Width/2))+90+360) Mod 360)
	#End If
End Sub

'click on campass label
#if B4A or B4i
Private Sub fLabelCompassDirection_Click
	CallSub2(mCallBack,mEventName & "_compassClicked",fMap.fCompassDirection)
End Sub
#Else if B4J
	Private Sub fLabelCompassDirection_MouseClicked (EventData As MouseEvent)
		CallSub2(mCallBack,mEventName & "_compassClicked",fMap.fCompassDirection)
	End Sub
#end if


Private Sub fPanelCompass_Touch (Action As Int, X As Float, Y As Float) As Boolean
	Return True
End Sub

Private Sub fPanelZoom_Touch (Action As Int, X As Float, Y As Float) As Boolean
	Return True
End Sub

'touch on map
Private Sub fPanelTouch_Touch (Action As Int, X As Float, Y As Float) As Boolean
	Select Case Action
		Case 0
			fLastTouch.fX=X
			fLastTouch.fY=Y
			fStartTouch.fX=X
			fStartTouch.fY=y
		Case 1
			If X=fStartTouch.fX And Y=fStartTouch.fY Then
				Dim v As B4XView=PointToTile(X,Y)
				Dim m As B4XView=v.GetView(cTileLayerMarkers)
				For i=0 To m.NumberOfViews-1
					#if B4A or b4i
						Dim ma As Panel=m.GetView(i)
					#else if B4J
						Dim ma As Pane=m.GetView(i)
					#end if
					If (ma.Left<=x-v.left) And (ma.Left+ma.Width>=X-v.Left) And (ma.top<=y-v.top) And (ma.top+ma.Height>=y-v.top) Then
						CallSub2(mCallBack,mEventName & "_markerClicked",ma.tag)
						Return True
					End If
				Next
				CallSub2(mCallBack,mEventName & "_mapClicked",PointToLatLng(coMapUtilities.initPoint(X,Y)))
			End If
		Case 2
			If Not(fIsMoving) Then
				fIsMoving=True
				moveTiles(0,X-fLastTouch.fx,Y-fLastTouch.fy)
				fMap.fCenterLatLng=MapCenterToLatLng
				update_CenterLatLng
				update_Scale
				fLastTouch.fX=X
				fLastTouch.fY=y
				fIsMoving=False
			End If
	End Select
	Return False
End Sub

private Sub getMapTileMAnager As clMapTileManager
	Return fMapTileManager
End Sub

public Sub updateGPS(aGPS As TMapGPS)
	fMap.fGPS=aGPS
	For i=0 To fPanelTiles.NumberOfViews-1
		Dim v As B4XView=fPanelTiles.GetView(i)
		Dim pp As B4XView=v.GetView(cTileLayerGPS)
		pp.RemoveAllViews
		drawGPSOnTile(pp)
	Next
End Sub

private Sub gps_click
	CallSub2(mCallBack,mEventName & "_gpsclicked",fMap.fGPS)
End Sub

Private Sub fPanelCenter_Touch (Action As Int, X As Float, Y As Float) As Boolean
	fPanelTouch_Touch(Action,X,Y)
	Return True
End Sub

Private Sub fPanelLandmark_Touch (Action As Int, X As Float, Y As Float) As Boolean
	fPanelTouch_Touch(Action,X,Y)
	Return True
End Sub

#If b4i
Private Sub fPanelControls_Touch(Action As Int, X As Float, Y As Float)
	fPanelTouch_Touch(Action,X,Y)
End Sub
#end if
